<template>
  <div class="app-pagination">
    <div class="page-total">
      合計: {{ total }} {{ itemName }}
    </div>

    <select
      class="form-control"
      @change="onPageSizeChange(+$event.target.value)"
    >
      <option v-for="(item, index) in PAGE_SIZES" :key="index" :value="item">
        {{ item }}
      </option>
    </select>

    <CPagination
      :active-page="currentPage"
      :pages="totalPage"
      :align="align"
      :size="size"
      :dots="dots"
      :arrows="arrows"
      :double-arrows="doubleArrows"
      :disabled="disabled || !total"
      class="nav-pagination"
      @update:activePage="onPageChange"
    />
  </div>
</template>

<style lang="scss" scoped>
  .app-pagination {
    /deep/ {
      display: flex;
      flex-direction: row;
      flex-wrap: wrap;
      justify-content: flex-end;
      align-items: center;
      margin-top: 0.25rem;
      margin-bottom: 0.25rem;
      > * {
        margin-top: 0.25rem;
        margin-bottom: 0.25rem;
      }
      .page-total {
        white-space: nowrap;
      }
      select {
        width: auto;
        margin-left: 0.5rem;
      }
    }
  }

  .nav-pagination {
    margin-left: 0.5rem;
  }

  .nav-pagination[disabled] {
    /deep/ {
      .page-item {
        .page-link {
          pointer-events: none;
          cursor: auto;
          color: #8a93a2;
          background-color: #fff;
          border-color: #c4c9d0;
          outline: 0;
          box-shadow: none;
        }
      }
    }
  }
</style>

<script>
import { PAGE_SIZES } from '~/constants'

const EVENT_PAGE_SIZE_CHANGE = 'page-size-change'
const EVENT_PAGE_CHANGE = 'page-change'

export default {
  props: {
    /**
     * Total record
     */
    total: {
      type: Number,
      default: null
    },

    /**
     * Number of items per page
     */
    pageSize: {
      type: Number,
      default: PAGE_SIZES[0]
    },

    /**
     * Current page
     */
    currentPage: {
      type: Number,
      default: 1
    },

    /**
     * Item name
     */
    itemName: {
      type: String,
      default: ''
    },

    /**
     * Disabled status
     */
    disabled: {
      type: Boolean,
      default: false
    },

    /**
     * Size of pagination. Valid values: 'sm', 'lg'
     */
    align: {
      type: String,
      default: 'end'
    },

    /**
     * Size of pagination. Valid values: 'sm', 'lg'
     */
    size: {
      type: String,
      default: null
    },

    /**
     * Sets dots elements (more content indicators) in pagination
     */
    dots: {
      type: Boolean,
      default: true
    },

    /**
     * Sets arrow elements (previous page, next page) in pagination
     */
    arrows: {
      type: Boolean,
      default: true
    },

    /**
     * Sets double-arrow elements (to first, to last page) in pagination
     */
    doubleArrows: {
      type: Boolean,
      default: true
    }
  },

  computed: {
    /**
     * Get total page
     *
     * @return {Number} Total page
     */
    totalPage () {
      return Math.ceil(this.total / this.pageSize)
    },

    /**
     * Get PAGE_SIZES
     *
     * @return {Array} PAGE_SIZES
     */
    PAGE_SIZES () {
      return PAGE_SIZES
    }
  },

  methods: {
    /**
     * Event when click to page number
     *
     * @param {Number} val - Page number
     */
    onPageChange (val) {
      this.$emit(EVENT_PAGE_CHANGE, +val)
    },

    /**
     * Event when change option page size number
     *
     * @param {Number} val - Page size number
     */
    onPageSizeChange (val) {
      this.$emit(EVENT_PAGE_SIZE_CHANGE, +val)
    }
  }
}
</script>
